package cz.fidentis.analyst.mesh.KdTree;

import cz.fidentis.analyst.mesh.core.MeshPoint;


public class KdNode {
    private int index;
    // represents index of vertices in the class MashFacetImpl in the attribute vertices
    private final int depth;
    private MeshPoint id;

    private KdNode lesser = null;
    private KdNode greater = null;
    private KdNode parent;

    public KdNode(int index, int depth, MeshPoint id, KdNode parent) {
        this.index = index;
        this.depth = depth;
        this.id = id;
        this.parent = parent;
    }

    public int getIndex() {
        return index;
    }

    public int getDepth() {
        return depth;
    }

    public MeshPoint getId() {
        return id;
    }

    public KdNode getLesser() {
        return lesser;
    }

    public KdNode getGreater() {
        return greater;
    }

    public KdNode getParent() {
        return parent;
    }

    public KdNode setId(MeshPoint id) {
        this.id = id;
        return this;
    }

    public KdNode setLesser(KdNode lesser) {
        this.lesser = lesser;
        return this;
    }

    public KdNode setGreater(KdNode greater) {
        this.greater = greater;
        return this;
    }

    public KdNode setParent(KdNode parent) {
        this.parent = parent;
        return this;
    }
}
